UIPackage
Menu

Framework

Change language

Boilerplate repo

Icons

iconsui

Showcase + recipe page for the registry’s default icon set (Lucide). Not a runtime component — install the npm package directly. Documented here so consumers can browse names and import recipes.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/icons.json
Named registry:npx shadcn@latest add @uipkge-react/iconsInstalls to:components/ui/icons/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
size

Size

'xs' | 'sm' | 'md' | 'lg' | 'xl' | '2xl' | 'inherit'optional
color

Color

stringoptional
className

Custom class for icon libraries (fa-, mdi-, etc.)

stringoptional
src

For img-based icons

stringoptional
altstringoptional
rotation

Rotation/flip

number | stringoptional
flip'horizontal' | 'vertical' | 'both'optional
label

A11y

stringoptional
ariaLabelstringoptional
inline

Style

booleanoptional
children

Slot-based icon (Lucide, Heroicons, inline SVG)

React.ReactNodeoptional

Files installed (2)

  • components/ui/icons/icons.tsx3.4 kB
    import * as React from 'react'
    import { cn } from '@/lib/utils'
    
    /**
     * Universal Icon component supporting multiple icon libraries:
     * - Lucide (default, via children)
     * - Font Awesome (via className with fa-* classes)
     * - Material Design Icons (via className with mdi-* classes)
     * - Heroicons (via children)
     * - Custom SVG (via src prop)
     */
    export interface IconProps {
      // Size
      size?: 'xs' | 'sm' | 'md' | 'lg' | 'xl' | '2xl' | 'inherit'
      // Color
      color?: string
      // Custom class for icon libraries (fa-, mdi-, etc.)
      className?: string
      // For img-based icons
      src?: string
      alt?: string
      // Rotation/flip
      rotation?: number | string
      flip?: 'horizontal' | 'vertical' | 'both'
      // A11y
      label?: string
      ariaLabel?: string
      // Style
      inline?: boolean
      // Slot-based icon (Lucide, Heroicons, inline SVG)
      children?: React.ReactNode
    }
    
    const sizeClasses: Record<NonNullable<IconProps['size']>, string> = {
      xs: 'size-3',
      sm: 'size-4',
      md: 'size-5',
      lg: 'size-6',
      xl: 'size-8',
      '2xl': 'size-12',
      inherit: 'size-full',
    }
    
    function Icon({
      size = 'md',
      color,
      className,
      src,
      alt,
      rotation,
      flip,
      label,
      ariaLabel,
      inline = true,
      children,
    }: IconProps) {
      const rotationDeg = rotation ? (typeof rotation === 'string' ? parseInt(rotation) : rotation) : undefined
      const accessibleName = ariaLabel || label
    
      const flipClasses =
        flip === 'horizontal'
          ? '-scale-x-100'
          : flip === 'vertical'
            ? '-scale-y-100'
            : flip === 'both'
              ? '-scale-x-100 -scale-y-100'
              : ''
    
      // Image-based icon (Material Design, custom URLs, etc.)
      if (src) {
        return (
          <img
            data-uipkge=""
            data-slot="icon"
            src={src}
            alt={alt || label || ''}
            className={cn(
              'shrink-0 object-contain',
              inline ? 'inline-block' : 'block',
              size !== 'inherit' ? sizeClasses[size] : '',
              flipClasses,
              className,
            )}
            style={{
              color,
              transform: rotationDeg ? `rotate(${rotationDeg}deg)` : undefined,
            }}
            aria-label={accessibleName || undefined}
            role="img"
          />
        )
      }
    
      // Slot-based icon (Lucide, Heroicons, inline SVG)
      return (
        <span
          data-uipkge=""
          data-slot="icon"
          className={cn(
            'shrink-0 items-center justify-center',
            inline ? 'inline-flex' : 'flex',
            size !== 'inherit' ? sizeClasses[size] : '',
            flipClasses,
            className,
          )}
          style={{
            color,
            transform: rotationDeg ? `rotate(${rotationDeg}deg)` : undefined,
          }}
          aria-label={accessibleName || undefined}
          role={accessibleName ? 'img' : undefined}
          aria-hidden={accessibleName ? undefined : true}
        >
          {children}
        </span>
      )
    }
    
    // Icon library class prefixes for reference:
    // Font Awesome: 'fa-solid', 'fa-regular', 'fa-brands', 'fa-*'
    // Material Design: 'mdi mdi-*'
    // Heroicons: already SVG-based, use children
    
    // Helper function to generate Font Awesome class
    export function faClass(iconName: string, style: 'solid' | 'regular' | 'brands' = 'solid'): string {
      const prefix = style === 'brands' ? 'fab' : style === 'solid' ? 'fas' : 'far'
      return `${prefix} fa-${iconName}`
    }
    
    // Helper function to generate Material Design class
    export function mdiClass(iconName: string): string {
      return `mdi mdi-${iconName}`
    }
    
    export { Icon }
    
  • components/ui/icons/index.ts0.1 kB

Raw manifest:https://uipkge.dev/r/react/icons.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Icons

iconsui

Showcase + recipe page for the registry’s default icon set (Lucide). Not a runtime component — install the npm package directly. Documented here so consumers can browse names and import recipes.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/icons.json
Named registry:npx shadcn-vue@latest add @uipkge/iconsInstalls to:app/components/ui/icons/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
size

Size

'xs''sm''md''lg''xl''2xl''inherit'
'md'optional
color

Color

stringoptional
class

Custom class for icon libraries (fa-, mdi-, etc.)

HTMLAttributes['class']optional
src

For img-based icons

stringoptional
altstringoptional
rotation

Rotation/flip

number | stringoptional
flip
'horizontal''vertical''both'
optional
label

A11y

stringoptional
ariaLabelstringoptional
inline

Style

booleantrueoptional

Files installed (2)

  • app/components/ui/icons/Icon.vue2.7 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import type { HTMLAttributes } from 'vue'
    import { cn } from '@/lib/utils'
    
    /**
     * Universal Icon component supporting multiple icon libraries:
     * - Lucide (default, via slot)
     * - Font Awesome (via class:fa-* and :class)
     * - Material Design Icons (via class:mdi-* and :class)
     * - Heroicons (via slot)
     * - Custom SVG (via src prop)
     */
    const props = withDefaults(
      defineProps<{
        // Size
        size?: 'xs' | 'sm' | 'md' | 'lg' | 'xl' | '2xl' | 'inherit'
        // Color
        color?: string
        // Custom class for icon libraries (fa-, mdi-, etc.)
        class?: HTMLAttributes['class']
        // For img-based icons
        src?: string
        alt?: string
        // Rotation/flip
        rotation?: number | string
        flip?: 'horizontal' | 'vertical' | 'both'
        // A11y
        label?: string
        ariaLabel?: string
        // Style
        inline?: boolean
      }>(),
      {
        size: 'md',
        inline: true,
      },
    )
    
    const sizeClasses = {
      xs: 'size-3',
      sm: 'size-4',
      md: 'size-5',
      lg: 'size-6',
      xl: 'size-8',
      '2xl': 'size-12',
      inherit: 'size-full',
    }
    
    const rotationDeg = computed(() => {
      if (!props.rotation) return undefined
      return typeof props.rotation === 'string' ? parseInt(props.rotation) : props.rotation
    })
    
    const flipClasses = computed(() => {
      if (!props.flip) return ''
      if (props.flip === 'horizontal') return '-scale-x-100'
      if (props.flip === 'vertical') return '-scale-y-100'
      if (props.flip === 'both') return '-scale-x-100 -scale-y-100'
      return ''
    })
    </script>
    
    <template>
      <!-- Image-based icon (Material Design, custom URLs, etc.) -->
      <img
        v-if="src"
        data-uipkge
        data-slot="icon"
        :src="src"
        :alt="alt || label || ''"
        :class="
          cn(
            'shrink-0 object-contain',
            inline ? 'inline-block' : 'block',
            size !== 'inherit' ? sizeClasses[size] : '',
            flipClasses,
            props.class,
          )
        "
        :style="{
          color: color,
          transform: rotationDeg ? `rotate(${rotationDeg}deg)` : undefined,
        }"
        :aria-label="ariaLabel || label || undefined"
        role="img"
      />
    
      <!-- Slot-based icon (Lucide, Heroicons, inline SVG) -->
      <span
        v-else
        data-uipkge
        data-slot="icon"
        :class="
          cn(
            'shrink-0 items-center justify-center',
            inline ? 'inline-flex' : 'flex',
            size !== 'inherit' ? sizeClasses[size] : '',
            flipClasses,
            props.class,
          )
        "
        :style="{
          color: color,
          transform: rotationDeg ? `rotate(${rotationDeg}deg)` : undefined,
        }"
        :aria-label="ariaLabel || label || undefined"
        :role="ariaLabel || label ? 'img' : undefined"
        :aria-hidden="!(ariaLabel || label) ? 'true' : undefined"
      >
        <slot />
      </span>
    </template>
    
  • app/components/ui/icons/index.ts0.6 kB

Raw manifest:https://uipkge.dev/r/vue/icons.json